#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#define INTSIZE 32

main() {
  FILE *fi; 
  int fo;
  char magic[10];
  unsigned int i, x, y, maxMag;
  unsigned int valTemp, valHolder, val; 
  unsigned int size, spaceUsed, spaceLeft;
  unsigned int count;

  fi = fopen("eq_0.pgm", "r");
  if (!fi) {
    printf("Error opening file\n");
    exit(1);
  }
  fo = open("eq_0.raw", O_WRONLY|O_CREAT, 0666);
  if (!fo) {
    printf("Error opening output file\n");
    exit(1);
  }
  fscanf(fi, "%s", &magic);
  fscanf(fi, "%d %d", &x, &y);
  fscanf(fi, "%d", &maxMag);
  printf("finished reading header\n");
  printf("%s\n", magic);
  printf("%d %d\n", x, y);
  printf("%d\n", maxMag);

  size = 10;                         /* no. of bits/symbol */
  spaceUsed = 0;                     /* bits used in integer holder */
  spaceLeft = INTSIZE;               /* bits left unused in holder */
  valHolder = 0;                     /* integer (32 bits) value holder */
  count = 0;
  while (count < x*y) {
    size = 10;                       /* no. of bits/symbol */
    fscanf(fi, "%d", &val);
    count++;
#if 0
    printf("count = %d    val = %d\n", count, val);
#endif
    if (spaceUsed > INTSIZE - size) {      /* no space for full symbol */
      spaceLeft = INTSIZE - spaceUsed;     /* how much space left? */
      valTemp = val >> (size - spaceLeft); /* leave hi bits on low space left */
      valHolder |= valTemp;                /* OR into value holder */ 
      size -= spaceLeft;                   /* remains of last symbol? */
#if 0
printf("val %X, left %d, temp %X, Hold %X\n", val, 
        spaceLeft, valTemp, valHolder);
getchar();
#endif
      write(fo, (char *)&valHolder, sizeof(int)); /* OUTPUT to raw image file */
      spaceUsed = 0;                       /* clear holder */ 
      valHolder &= 0;                      
    }
    valTemp = val << (INTSIZE - size) - spaceUsed; 
    valHolder |= valTemp;
    spaceUsed += size;
#if 0
printf("val %X, shift %d, temp %X, used %d, Hold %X\n", val, 
        INTSIZE-spaceUsed,
        valTemp, spaceUsed, valHolder);
#endif
  }  /* end while */

  if (spaceUsed != 0) {
      write(fo, (char *)&valHolder, sizeof(int)); /* OUTPUT to image file */
  }

  fclose(fi);
  close(fo);
}



